/*
	"abilityX"
	{
		"name"	"special_olaf"
		"arg1"	"25.0"												// Damage (snowballs)
		"arg2"	"5.0"												// Wet Duration (from melee hit)
		"arg3"	"5.0"												// How many seconds to be frozen
		"plugin_name"	"ff2_olaf"
	}
*/


#pragma semicolon 1
#include <sourcemod>
#include <tf2_stocks>
#include <sdkhooks>
#include <morecolors>
#include <freak_fortress_2>
#include <freak_fortress_2_subplugin>

#define SNOWBALL_PROJECTILE "tf_weapon_jar_milk"

#pragma newdecls required

public Plugin myinfo = {
	name = "Freak Fortress 2: Olaf's ability",
	author = "SHADoWNiNETR3S",
	version = "1.0",
};

bool IsPlayerFrozen[MAXPLAYERS+1]=false;
float UnFreezePlayerAt[MAXPLAYERS+1]=0.0;

public void OnPluginStart2()
{
	HookEvent("arena_round_start", Event_RoundStart);
	if(FF2_GetRoundState()==1)
	{
		HookDamage();
	}
}

public void Event_RoundStart(Event event, const char[] name,  bool dontBroadcast)
{
	HookDamage();
}

void HookDamage()
{
	for(int client=1;client<=MaxClients;client++)
	{
		if(!IsValidClient(client))
			continue;
		IsPlayerFrozen[client]=false;
			
		int boss=FF2_GetBossIndex(client);
		if(boss>=0 && FF2_HasAbility(boss, this_plugin_name, "special_olaf"))
		{
			HookUserMessage(GetUserMessageId("PlayerJarated"), Event_Wet);
			for(int player=1;player<=MaxClients;player++)
			{
				if(!IsValidClient(player))
					continue;
				SDKHook(player, SDKHook_OnTakeDamage, OnTakeDamage);
			}
		}
	}
}

public Action Event_Wet(UserMsg msg_id, BfRead msg, const int[] players, int playersNum, bool reliable, bool init)
{
	int client = BfReadByte(msg);
	int victim = BfReadByte(msg);

	int boss=FF2_GetBossIndex(client);
	
	if(boss>=0 && IsValidClient(victim) && FF2_HasAbility(boss, this_plugin_name, "special_olaf"))
	{
		static bool isWet=false;
		if(!IsPlayerFrozen[victim])
		{
			if(!isWet)
			{
				isWet=true;
			}
			else
			{
				isWet=false;
				FreezeTarget(victim, FF2_GetAbilityArgumentFloat(boss, this_plugin_name, "special_olaf", 2, 5.0));
				TF2_RemoveCondition(victim, TFCond_Milked);
			}
		}
		else
		{
			TF2_RemoveCondition(victim, TFCond_Milked);
		}
	}
	return Plugin_Continue;
}

public Action OnTakeDamage(int client, int &attacker, int &inflictor, float &damage, int &damagetype, int &weapon, float damageForce[3], float damagePosition[3], int damagecustom)
{		
	int boss=FF2_GetBossIndex(attacker);
	if(boss>=0 && FF2_HasAbility(boss, this_plugin_name, "special_olaf") && damage>0 && IsValidClient(client) && client!=attacker)
	{
		if(TF2_IsPlayerInCondition(client, TFCond_Milked))
		{
			TF2_RemoveCondition(client, TFCond_Milked);
			FreezeTarget(client, FF2_GetAbilityArgumentFloat(boss, this_plugin_name, "special_olaf", 2, 5.0));
			return Plugin_Stop;
		}
		else
		{
			if(!IsPlayerFrozen[client])
			{
				TF2_AddCondition(client, TFCond_Milked, FF2_GetAbilityArgumentFloat(boss, this_plugin_name, "special_olaf", 1, 5.0));
			}
		}
	}
	return Plugin_Continue;
}

stock bool IsValidClient(int client, bool lifecheck=false)
{
    if(client<=0 || client>MaxClients) return false;
    return lifecheck ? IsClientInGame(client) && IsPlayerAlive(client) : IsClientInGame(client);
}


stock void FreezeTarget(int clientIdx, float freezetime)
{
	if(!IsPlayerFrozen[clientIdx])
	{
		int ragdoll[MAXPLAYERS+1];
		IsPlayerFrozen[clientIdx]=true;
		SetEntityMoveType(clientIdx, MOVETYPE_NONE);
		ColorizePlayer(clientIdx, {255,255,255,0});
		ragdoll[clientIdx]= CreateEntityByName("tf_ragdoll");
		if(ragdoll[clientIdx] > MaxClients && IsValidEntity(ragdoll[clientIdx]))
		{
			float flPos[3], flAng[3],flVel[3];
			GetClientAbsOrigin(clientIdx, flPos);
			GetClientAbsAngles(clientIdx, flAng);
		
			TeleportEntity(ragdoll[clientIdx], flPos, flAng, flVel);
		
			SetEntProp(ragdoll[clientIdx], Prop_Send, "m_iPlayerIndex", clientIdx);
			SetEntProp(ragdoll[clientIdx], Prop_Send, "m_bIceRagdoll", 1);
			SetEntProp(ragdoll[clientIdx], Prop_Send, "m_iTeam", GetClientTeam(clientIdx));
			SetEntProp(ragdoll[clientIdx], Prop_Send, "m_iClass", (view_as<int>(TF2_GetPlayerClass(clientIdx))));
			SetEntProp(ragdoll[clientIdx], Prop_Send, "m_bOnGround", 1);
	
			SetEntityMoveType(ragdoll[clientIdx], MOVETYPE_NONE);
		
			DispatchSpawn(ragdoll[clientIdx]);
			ActivateEntity(ragdoll[clientIdx]);
	
			SetClientViewEntity(clientIdx, ragdoll[clientIdx]);
			SetThirdPerson(clientIdx, true);
	
			CreateTimer(freezetime, Timer_DeleteParticle, EntIndexToEntRef(ragdoll[clientIdx]));
			
			UnFreezePlayerAt[clientIdx]=GetEngineTime()+freezetime;
		
			for(int slot=0;slot<=5;slot++)
			{
				int weapon=GetPlayerWeaponSlot(clientIdx, slot);
				if(weapon && IsValidEdict(weapon))
				{
					SetEntPropFloat(weapon, Prop_Send, "m_flNextPrimaryAttack", GetGameTime()+freezetime);
				}
			}
			SetEntPropFloat(clientIdx, Prop_Send, "m_flNextAttack", GetGameTime()+freezetime);
			if(TF2_GetPlayerClass(clientIdx)==TFClass_Spy)
			{
				SetEntPropFloat(clientIdx, Prop_Send, "m_flStealthNextChangeTime", GetGameTime()+freezetime);
			}
			
			if(GetEntProp(clientIdx, Prop_Send, "m_bGlowEnabled"))
			{
				SetEntProp(clientIdx, Prop_Send, "m_bGlowEnabled", 0);
			}
			
			SDKHook(clientIdx, SDKHook_PreThink, UnfreezeTime_PreThink);
		}
	}
}

public void UnfreezeTime_PreThink(int clientIdx)
{
	if(!IsValidClient(clientIdx, true) || FF2_GetRoundState()!=1)
	{
		UnFreezePlayerAt[clientIdx]=0.0;
		IsPlayerFrozen[clientIdx]=false;
		UnFreezePlayer(clientIdx);
		SDKUnhook(clientIdx, SDKHook_PreThink, UnfreezeTime_PreThink);
	}
	
	if((GetEngineTime() >= UnFreezePlayerAt[clientIdx]) && UnFreezePlayerAt[clientIdx]>0.0)
	{
		UnFreezePlayerAt[clientIdx]=0.0;
		IsPlayerFrozen[clientIdx]=false;
		UnFreezePlayer(clientIdx);
		SDKUnhook(clientIdx, SDKHook_PreThink, UnfreezeTime_PreThink);
	}
}

public void UnFreezePlayer(int clientIdx)
{
	SetClientViewEntity(clientIdx, clientIdx);
	SetEntityMoveType(clientIdx, MOVETYPE_WALK);
	ColorizePlayer(clientIdx, {255,255,255,255});
	SetThirdPerson(clientIdx, false);
}

public void SetThirdPerson(int clientIdx, bool bEnabled)
{
	if(bEnabled)
	{
		SetVariantInt(1);
	}else{
		SetVariantInt(0);
	}
	AcceptEntityInput(clientIdx, "SetForcedTauntCam");
}

public void SetEntityColor(int entity, int color[4])
{
	SetEntityRenderMode(entity, RENDER_TRANSCOLOR);
	SetEntityRenderColor(entity, color[0], color[1], color[2], color[3]);
}

public void ColorizePlayer(int clientIdx, int color[4])
{
	SetEntityColor(clientIdx, color);
	for(int i=0; i<5; i++)
	{
		int weapon = GetPlayerWeaponSlot(clientIdx, i);
		if(weapon > MaxClients && IsValidEntity(weapon))
		{
			SetEntityColor(weapon, color);
		}
	}
	
	char strClass[20];
	for(int wearable=MaxClients+1; wearable<GetMaxEntities(); wearable++)
	{
		if(IsValidEntity(wearable))
		{
			GetEntityClassname(wearable, strClass, sizeof(strClass));
			if((!StrContains(strClass, "tf_wearable", false) || !StrContains(strClass, "tf_powerup", false)) && GetEntPropEnt(wearable, Prop_Send, "m_hOwnerEntity") == clientIdx)
			{
				SetEntityColor(wearable, color);
			}
		}
	}

	int weapon = GetEntPropEnt(clientIdx, Prop_Send, "m_hDisguiseWeapon");
	if(weapon > MaxClients && IsValidEntity(weapon))
	{
		SetEntityColor(weapon, color);
	}
}

public Action Timer_DeleteParticle(Handle hTimer, any entref)
{
	int entity = EntRefToEntIndex(entref);
	if(entity > MaxClients)
	{
		AcceptEntityInput(entity, "Kill");
	}
	return Plugin_Handled;
}

public void FF2_OnAbility2(int boss,const char[] plugin_name,const char[] ability_name,int action)
{
	// never used.
	return;
}